<?
if(!defined('__xk_INIT__')){die('att at');}

require_once($SYSPATH.'funcs/xml/spoxml.php');

$userLogin = ValidReqVar('ulogin');

if($use_flat_db){
	$uorders = $xkdb->select('users2orders', $userLogin);
}else{
	$res = $Db->selectOne(array(
					't'=>'users',
					's'=>'id',
					'w'=>array('login=?', $userLogin)			
			));
	if($res){
		$orders = $Db->select(array(
					't'=>'orders',
					's'=>'id',
					'w'=>array('user_id=? and lab_id=?', $userLogin, get_lab_id())			
			));
	}		
	if(!$res || !$orders){
		$uorders=false;
	}else{
		foreach ($orders as $o){
			$uorders[] = $o->id;		
		}
	}
}


if($uorders==false){
	echo 'orders=none';
	exit;
}


$oout=array();
$oout_i=0;
foreach ($uorders as $ord){
	$fn = $SETTINGS['orders web dir'].'/'.$ord.'/report.spo.xml';
	$origpathplace = $SETTINGS['orders web dir'].'/'.$ord.'/origpath.xkp';
	$origpath = base64_decode(@file_get_contents($origpathplace));
	if(!(file_exists($origpath) && is_dir($origpath)))
		$origpath = '*no*';	
	if(file_exists($fn)){
		$spo = new spoxml($fn);
		$oout[$oout_i]['status'] = 
			read_file($SETTINGS['orders web dir'].'/'.$ord.'/_status.xko', 'p');		
		$oout[$oout_i]['origpath'] = ($origpath);
		$oout[$oout_i]['order_num'] = $ord;
		$oout[$oout_i]['photos_num'] = $spo->get_photo_total();
		$oout[$oout_i]['cds'] =$spo->getCds();
		$oout[$oout_i]['cds_num'] = $spo->getCdsNum();
		list($pri, )=explode(' (', $spo->get_user_info('price'));
		$oout[$oout_i]['price'] = $pri;
		$oout[$oout_i]['dm'] = $spo->get_user_info('*** Delivery method ***');
		$oout[$oout_i]['pmt'] = $spo->get_user_info('__payment_method');
		if($oout[$oout_i]['pmt']==false)$oout[$oout_i]['pmt']='none';
		$ph = $spo->get_photo(0);
		$oout[$oout_i]['ph0'] = $ph['name'];
		$ph = $spo->get_photo(1);
		$oout[$oout_i]['ph1'] = $ph['name'];
		$priadd = $spo->get_user_info('*** Shipping price (not included to a full price) ***');
		if($priadd!==false){
			list($priadd, )=explode(' (', $priadd);			
			$oout[$oout_i]['price_shipping'] = $priadd;
		}
		$oout[$oout_i]['i']= $oout_i;
		$oout_i++;	
		unset($spo);
	}
}

$spl = "&";
if($spl=="\n") header('content-type: text/plain');
echo 'ot='.count($oout).$spl;
foreach ($oout as $o){
	$i = $o['i'];
	echo 'o'.$i.'_nm='.urlencode($o['order_num']).$spl;
	echo 'o'.$i.'_pn='.urlencode($o['photos_num']).$spl;
	echo 'o'.$i.'_cd='.urlencode($o['cds']).$spl;
	echo 'o'.$i.'_cn='.urlencode($o['cds_num']).$spl;
	echo 'o'.$i.'_op='.urlencode($o['origpath']).$spl;
	echo 'o'.$i.'_pr='.urlencode($o['price']).$spl;
	echo 'o'.$i.'_pmt='.urlencode($o['pmt']).$spl;
	if(isset($o['price_shipping']))	
		echo 'o'.$i.'_ps='.urlencode($o['price_shipping']).$spl;
	echo 'o'.$i.'_dm='.urlencode($o['dm']).$spl;
	echo 'o'.$i.'_st='.urlencode($o['status']).$spl;
	echo 'o'.$i.'_p0='.urlencode($o['ph0']).$spl;
	echo 'o'.$i.'_p1='.urlencode($o['ph1']).$spl;
}
//var_dump($oout);

exit;


?>