<?
$xkdb->open_settings('editor');
function get_filter_num($filterc){
	if($filterc=='') return 0;
	$fexp = explode('::', $filterc);
	if($fexp==$filterc)return 1;
	return count($fexp);	
}
function get_filter_md5($fnum='all', $filterc){
	// filterc = "redeye:x.xxx;y.yyy;w.www;h.hhh::crop:x.xxx;y.yyy;w.www;h.hhh ..."
	if($filterc=='') return 'no_filter';
	$v = $filterc;
	if($fnum!='all'){
		$farray = explode('::', $v);
		$farray2 = array();
		for($i=0;$i<intval($fnum);++$i)
			array_push($farray2, $farray[$i]);
		$v = implode('::', $farray2);	
	}	
	return 'p_'.md5('f'.$v);
}
function get_bigphoto_src_name_p($photoname, $inv=''){
	return $photoname.'.src'.$inv.'.jpg';	
}
function get_bighoto_thumb_name($photoname){
	return $photoname.'.thumb.'.ValidReqVar('xy2', ValidReqVar('xy')).'.jpg';	
}
function get_bighoto_src_name($photoname,$filterc){
	$GLOBALS['filters_last_filter_num'] = 0;
	if($filterc=='' ||ValidReqVar('xkdtreshold')) return $photoname;
	$fnum = get_filter_num($filterc);
	for($i=$fnum;$i>0;--$i){
		$fna = get_bigphoto_src_name_p($photoname, get_filter_md5($i, $filterc));
		if(file_exists($fna)){
			$GLOBALS['filters_last_filter_num'] = $i;
			return $fna;
		}
	}
	return $photoname;
}
function do_apply_filters($photoname, $filterc){
	llog("raw filterc: $filterc");
	$srcfn = $photoname;
	$photoname = get_bighoto_src_name($photoname, $filterc);
	$thumbname = get_bighoto_thumb_name($photoname);	
	llog("I start from $photoname");
	$fnum = get_filter_num($filterc);
	llog("num: ".$fnum);
	if($filterc=='') return array($photoname, $thumbname);
	$farray = explode('::', $filterc);
	if($farray==$filterc)$farray[0]=$farray;
	llog("farray: ".print_r($farray, true)." ");
	$last_filter_n = $GLOBALS['filters_last_filter_num'];
	$only1redeye=false;
	if($last_filter_n+1 == $fnum && ValidReqVar('redeyepost')!='y'){
		$ii = $last_filter_n;		
		list($cfitername, $dims) = explode(':', $farray[$ii]);
		llog("I have only one filter to apply!!!: $cfitername");		
		if($cfitername=='redeye')
			$only1redeye=true;
	}
	$actual_name = $only1redeye?$thumbname:$photoname;
	$GLOBALS['only1redeye'] = $only1redeye;
	llog('we will work on this image: '.$actual_name);
	$im = xk_editor_open_file($actual_name);	
	llog("last filter: ".$GLOBALS['filters_last_filter_num']);
	for($i=$last_filter_n+1;$i<=$fnum;++$i){
		$ii=$i-1;
		llog($i.':'."\n   raw: ".$farray[$ii]);
		list($cfitername, $dims) = explode(':', $farray[$ii]);
		$sizesxy = array('width'=>imagesx($im['im']), 'height'=>imagesy($im['im']));
		llog("wh: ".print_r($sizesxy, true));
		$dims = explode(';', $dims);
		llog("dims before: ".print_r($dims, true));
		$dims = calc_real_dims($dims, $sizesxy);
		llog("dims after: ".print_r($dims, true));
		
		switch($cfitername){
			case 'redeye': $im = do_apply_filter_redeye($im, $dims); break;
			case 'crop': $im = do_apply_filter_crop($im, $dims); break;
		}
	}
	$photoname = get_bigphoto_src_name_p($srcfn, get_filter_md5('all', $filterc));
	$thumbname = get_bighoto_thumb_name($photoname);	
	$actual_name = $only1redeye?$thumbname:$photoname;
	llog('saving image as: '.$actual_name);
	llog_flush('filters');
	xk_editor_save_file($im, $actual_name, 100);
	if(ValidReqVar('redeyepost')=='y'){
		echo "success=y";
		exit;
	}
	 return array($photoname, $thumbname);
}
function do_apply_filter_redeye($im, $dim){	 
	$spot['x'] = min($dim['x'], $dim['xx']);
	$spot['y'] = min($dim['y'], $dim['yy']);
	$spot['diameter'] = abs($dim['xx']-$dim['x']);
	llog("   aplied filter red eye with  ".print_r($dim, true));
	return  xk_editor_redeye($im, $spot);
}
function do_apply_filter_crop($im, $dim){
	global $SETTINGS;
	llog("   aplied filter CROP with  ".print_r($dim, true));
	$gwidth = abs($dim['xx']-$dim['x']);
	$gheight = abs($dim['yy']-$dim['y']);
	$sample_x = $dim['x'];
	$sample_y = $dim['y'];
	$im2 = imagecreatetruecolor($gwidth, $gheight);
	$imt = $im['im'];	
	$funcname = $SETTINGS['imagecopy'];
	eval("imagecopy$funcname(\$im2, \$imt, 0, 0, \$sample_x, \$sample_y,".
											" \$gwidth, \$gheight, \$gwidth, \$gheight);");
	$im['im'] = $im2;
	return  $im;
}
?>