<?
$xkLanguage_DELIMITER_TOP = 
     "\n?==???=?====+====?+==?========+=++++++?+++=+++?=++==??\n"; 
$xkLanguage_DELIMITER_AND = 
     "\n&&&&&&?=?&&&&&&?&&&&&&&&?&&&&&&&?=?&&&&&&?&&&&&&&&?&\n"; 
$xkLanguage_DELIMITER_IS = "\n==?&?=\n";
     
class xkLanguage{
	var $default_language;
	function xkLanguage(){
		global $SETTINGS,$xkdb;
		$xkdb->open_settings('lang');
		$this->default_language = $SETTINGS['l_lang_d'];
	}
	function parse_language_file($lang=''){
		if($lang==='')$lang = $this->default_language;
		$lang = rawurldecode($lang);
		if(!$this->lang_exists($lang))return false;
		global 
			$xkLanguage_DELIMITER_TOP,
			$xkLanguage_DELIMITER_AND,
			$xkLanguage_DELIMITER_IS,
			$SYSPATH;
		$fname = $this->langpath($lang);
		$c = str_replace("\r", "", ($cc=file_get_contents($fname)));
		
		if($lang!='__bs_english')$c = xkdecode($c);
		// parsing the file:
		if(strpos($c, $xkLanguage_DELIMITER_TOP)){
			$l_base = explode($xkLanguage_DELIMITER_TOP,	$c);
			$escaped = $l_base[0]!='noescape';							
		}else{
			$l_base[1] = $c;
			$escaped = true;							
		}	

		$l_lang = 
			explode($xkLanguage_DELIMITER_AND, 
				$l_base[1]);
		foreach ($l_lang as $v){
			$ll = explode($xkLanguage_DELIMITER_IS, $v);
			$ret[$ll[0]] = $escaped?$ll[1]:rawurlencode($ll[1]);
		}
		return $ret;
	}	
	function save_language_file($l){
		global 
			$xkLanguage_DELIMITER_TOP,
			$xkLanguage_DELIMITER_AND,
			$xkLanguage_DELIMITER_IS;
		global $SYSPATH;
		$fname = $this->langpath($l['LANGUAGE NAME IN ENGLISH']);
		$contarr = array();
		foreach ($l as $k=>$v){
			$contarr[] = $k.$xkLanguage_DELIMITER_IS.$v;	
		}
		$fcont .= implode($xkLanguage_DELIMITER_AND, $contarr);
		save_file($fname, xkencode($fcont));
	}
	function lang_exists($l){
		global $SYSPATH;
		return file_exists($this->langpath($l));
	}
	function langpath($l){
		return $this->langdir().$l.'.xkl';
	}
	function langdir(){
		return $GLOBALS['xkdb']->get_firm_dir().'lang/';
	}
};

$language = new xkLanguage();

?>