<?
$glob_tbls= array('users', 'user_ids', 'users2orders', 'orders', 'laboratories');

class xkdb{
	var $dbpath;
	var $flat;
	function xkdb($dbpath=''){
		if(empty($dbpath)){
				$dbpath =  $GLOBALS['SYSPATH'].$GLOBALS['CONF']['db_dir'];			
		}
		$this->dbpath = $dbpath;
		$this->flat = $GLOBALS['use_flat_db'];
	}
	function select($table, $id=0, $decode=true){		
			$p1 = $this->path($table, $id, 'xkdb');
			$p2 = $this->path($table, $id);
			if(file_exists($p1)){
				$c = file_get_contents($p1);
			}else if(file_exists($p2)){
				$c = file_get_contents($p2);
			}else 	
				return false;
			if(substr($c, 0, 10)=='<?/*xkdb~ '){
				$c = substr($c, 10);
				$c = substr($c, 0, strlen($c)-4);
			}	
			$c = str_replace("\r", "", $c);			
			$cont = (explode("\n", ($c)));
			foreach ($cont as $c) {
				list($i, $v) = explode('  =  ', $c);
				$ret[urldecode($i)] = $this->xdecode($v, $decode);			
			}		
			return ValidVar($ret);
	}
	function select_ids($table){
		// finds and returns an array of all the IDs in the certain table:
		$spath = $this->path($table, 'tmpl');
		$ret = array();
		$spath = realpath(dirname($spath));
		if(!file_exists($spath)) return array();
		$d = dir($spath);
		while (false !== ($entry = $d->read())) {	
			list($fid, $ext) = explode('.', $entry);
			if($entry=='.' ||$entry=='..' ||
			!($ext=='php' || $ext=='xkdb')) continue;
			$fulp=$spath.'/'.$entry;
			$ret[] = $fid;
		}
		$d->close();
		return $ret;
		
	}
	// if id is not false - we replace the record
	function insert($table, $data, $id=false, $encode=true){
		if($id===false)
			for($id=0;true;++$id)
				if(!file_exists($this->path($table, $id))) break;
		if(count($data)<=0)
			return @unlink($this->path($table, $id));
		foreach ($data as $d => $t){
			$dat[] =urlencode($d).'  =  '.$this->xencode($t, $encode);
		}
		$savetxt = '<?/*xkdb~ '.implode("\n", $dat).'*/?>';
		$p1 = $this->path($table, $id, 'xkdb');
		$p2 = $this->path($table, $id);
		if(file_exists($p1)) unlink($p1);
		//echo "path to save the INSERT: $p2\n";
		return save_file($p2, $savetxt);
	}
	function open_settings($table){
		if($this->flat){
			if(($sel = $this->select($table))===false) return false;
			foreach ($sel as $k => $v){
				$GLOBALS['SETTINGS'][$k] = $v;
			}
		}else{
			global $Db;
			$res = $Db->select(array('t'=>'settings','w'=>
						array('stable=? and lab_id=?', $table, get_lab_id())));
			if(!$res) return false;
			foreach ($res as $r){
				$GLOBALS['SETTINGS'][$r->sname] = $r->svalue;				
			}
		}
		return true;
	}
	function save_settings($table, $data, $reset_settings=false){
			if($reset_settings)
				$GLOBALS['SETTINGS'] = array();			
			foreach ($data as $k => $v){
				$GLOBALS['SETTINGS'][$k] = $v;
			}
			if($this->flat) return  $this->insert($table, $data, 0);
			else{
				global $Db;
				foreach ($data as $k=>$v){
					$w = array('stable=? 
							and sname=? and lab_id=?', $table, $k, get_lab_id());
					$obj = array(
								'stable'=>$table,
								'lab_id'=>get_lab_id(),
								'sname'=>$k,
								'svalue'=>$v
								);
					$is = $Db->selectOne(array('t'=>'settings','w'=>$w));
					if(!$is){	$Db->insert('settings', $obj);}			
					else{	$Db->update('settings', $obj, $w);}			
				}				
			}	
			
	}
	function path($tbl, $fid, $ext='php'){
		global $glob_tbls;
		$isglb=false;		
		foreach ($glob_tbls as $t){
			if($t==$tbl){
				$isglb=true;
				break;		
			}	
		}
		$ipath = '';
		if(!$isglb){
			$labid = get_lab_id();
			$ipath = 'laboratories/'.$labid.'/';
		}
		$ipath .= urlencode($tbl);
		$llog_value='';
//		llog('Path for table "'.$tbl.'": '.$ipath);
//		llog_flush('for_table_'.$tbl);		
		return $this->dbpath.'/'.$ipath.'/'.$fid.'.'.$ext;
	}
	function xencode($v, $d=true){ 
			switch(gettype($v)){
				case 'boolean': $v = 'xkdb:'.($v?'true':'false'); break;
				case 'NULL': $v = 'xkdb:NULL'; break;				
				default: break;
			}
				return $d?urlencode($v):$v;
	}
	function xdecode($v, $d=true){ 
			$v = $d?urldecode($v):$v;
			switch($v){
				case 'xkdb:true': $v = true; break;
				case 'xkdb:false': $v = false; break;
				case 'xkdb:NULL': $v = null; break;				
				default: break;
			}
			if(strval(intval($v))==$v) $v = intval($v);
			return $v;  
	}
	function get_firm_dir(){
			$labid = get_lab_id();
			$ipath = 'laboratories/'.$labid.'/';		
			return $this->dbpath.'/'.$ipath.'_firm/';
	}
};
$xkdb = new xkdb();
//------------------------------------------------------------------


?>