<?
//////////////////////////////////////////////////////////////////////
function escape_string($string){
	if (is_null($string) || $string===false){
			 return null;
	}		 
   if(version_compare(phpversion(),"4.3.0")=="-1") {
     return mysql_escape_string($string);
   } else {
     return mysql_real_escape_string($string);
   }
} 
//////////////////////////////////////////////////////////////////////
class xkdb2
{
	//------------------------------------------------------------- - -
	var $link;
	var $auto_free;
	var $last_insert_id;
	var $last_query;
	var $last_error;
	//------------------------------------------------------------- - -
	function error($error, $l='?'){
		$this->last_error = $error;
		echo "<b>Warning Database error (on line: $l):</b>\n".$error."<br>\n";		
		die();
	}
	//------------------------------------------------------------- - -
	function xkdb2($ci)
	{
		if(!isset($ci['name']))$ci['name'] = $ci['user'];
		if(!isset($ci['user']))$ci['user'] = $ci['name'];
		if(!isset($ci['port']))$ci['port'] = '3306';
		if(false === 
				($this->link=mysql_connect(
						$ci['host'].':'.$ci['port'], $ci['user'], $ci['password'] )
				)){
		   			$this->error('Unable to connect: ' . mysql_error(), __LINE__);		    
		}			
		if(false===mysql_select_db($ci['name'])){
		   	$this->error('Unable to connect to '.$ci['dbname'], __LINE__);		    				
		}	
	}
	//------------------------------------------------------------- - -
	function close()
	{
		@mysql_close($this->link);
	}	
	//------------------------------------------------------------- - -
	/**
	 * inserts into $table the $data
	 *
	 * @param string $table
	 * @param hash $data
	 * @return bool
	 */
	function insert($table, $data){
		$q = 'insert into '.PFX.$table.' set '.$this->___parse_set_data($data);
		//$this->last_query = $q;
		$ret = $this->query_raw($q);
		$this->last_insert_id = mysql_insert_id($this->link);
		return $ret;
	}
	//------------------------------------------------------------- - -
	/**
	 * Updates $table with $data where $where
	 *
	 * @param string $table
	 * @param hash $data
	 * @param array_or_string $where
	 * @return bool
	 */
	function update($table, $data, $where=''){
		$where = (empty($where)?'':' where '.$this->___unescape_query($where));
		$q = 'update '.PFX.$table.' set '.$this->___parse_set_data($data).$where;
		return $this->query_raw($q);
	}
	//------------------------------------------------------------- - -
	/**
	 * Deletes from $table where $where
	 *
	 * @param string $table
	 * @param array_or_string $where
	 * @return bool
	 */
	function delete($table, $where=''){
		$q = 'delete from '.PFX.$table.
			(empty($where)?'':' where '.$this->___unescape_query($where));
		//$this->last_query = $q;
		return $this->query_raw($q);
	}
	//------------------------------------------------------------- - -
	/**
	 * selects from database (read description of ___create_query about argument)
	 *
	 * @param hash $o
	 */
	//------------------------------------------------------------- - -
	function select($o, $num='all'){
		$o['_action_'] = 'select';
		$q = $this->___create_query_select($o);
		//return $q;
		return $this->select_raw($q, $num);
	}
	//------------------------------------------------------------- - -
	function selectOne($o){
		$o['_action_'] = 'select';
		$q = $this->___create_query_select($o);
		return $this->select_raw($q, 1);
	}
	//------------------------------------------------------------- - -
	/**
	 * $num can be: "all" (select all) and  number( select that number of raws)
	 *
	 * @param query_string $q
	 * @param num_of_lines $num
	 */
	function select_raw($q, $num='all'){
		if($q==false) return false;
		$this->last_query = $q;
		if(false===($res = mysql_query($q, $this->link))){
   			$this->error('this select query<br>'.$q.'<br> failed: '.
   										mysql_error(), __LINE__);		    			
		}
		if(mysql_num_rows($res) == 0) return false;
		if($num==1){
			$dat = $this->fetch_object($res);
			return $dat;
		}else if($num=='all'){
			while($v = $this->fetch_object($res)) $ret[] = $v;
			return $ret;
		}else if(is_numeric($num) && $num > 0){
			while($num-- && ($v = $this->fetch_object($res))) $ret[] = $v;
			return $ret;
		}
		return false;
	}
	function fetch_object($res){
		$dat = mysql_fetch_assoc($res);
		if(!$dat)return false;
		foreach ($dat as $k=>$v){
			$dat[$k] = $this->dec_var($v);
		}
		settype($dat, 'object');
		return $dat;
	}
	//------------------------------------------------------------- - -
	function query_raw($q){
		if($q==false) return false;
		$this->last_query = $q;
		if(false===($res = mysql_query($q, $this->link))){
   			$this->error('this query<br>'.$q.'<br> failed: '.
   										mysql_error(), __LINE__);		    						   										
		}
		return true;		
	}
	//------------------------------------------------------------- - -
	/**
	 * prepare the query by object (read description!)
	 * o must contain:
	 * o['t']  - select from this table (without prefix)
	 *					string:"table" or string:"table as pseudon"
	 * o['s']  - what to select, if not set - select all (*)
	 *					can be a 
	 * 							simple string 
	 * 					or 
	 * 						an array of	strings "col as smth" or "tbl.col as smth" 
	 * o['j'] - joins. Must be 1 or an array of objects,
	 *						each one describing a join.
	 *						v['p']-position:'left','right','inner',default 'left'
	 *						v['t']-"table as pseu"				
	 *						v['on']-"on condition" (string or array)				
	 * o['w']  - where string or array:"smth" (not set - no "where")
	 * o['o'] - order by this string:"col" (not set - don't order)
	 * o['l'] - limit array(N1, N2) (not set - don't limit)
	 *
	 *
	 * @param hash $o
	 */
	function ___create_query_select($o){
		if(!isset($o['t']))return false;		
		
			// prepare s
			if(is_array($o_s=vvar($o['s']))) 
					$o['s'] = "         ".implode(",\n         ", $o['s']);
			else if(!isset($o['s']))$o['s']='         *';
			
			// prepare j
			if(!isset($o['j']))$o['j']=' ';
			else if(isset($o['j']['t'])){
				// this is a single join, parsing it:
				$o['j'] = "\n    ".$this->___parse_1_join($o['j']);
			}else if(is_array($o['j'])) {
				// multy
				foreach ($o['j'] as $k=>$v){
					$o['j'][$k] = $this->___parse_1_join($o['j'][$k]);					
				}
				$o['j'] = "\n    ".implode("\n    ", $o['j']);
			}	
			if(!isset($o['w']))$o['w']=' ';
			else $o['w']="\n".'where '.$this->___unescape_query($o['w']).' ';

			if(!isset($o['o']))$o['o']=' ';
			else $o['o']="\n".'order by '.$o['o'].' ';

			if(!isset($o['l']))$o['l']=' ';
			else $o['l']="\n".'limit '.
				(is_array($o['l'])?($o['l'][0].', '.$o['l'][1]):$o['l']).' ';
			
			return trim("select \n".$o['s']."\n".'from '.PFX.$o['t'].' '
				.$o['j'].' '.$o['w'].' '.$o['o'].' '.$o['l']);
	}		
	//------------------------------------------------------------- - -
	function ___parse_1_join($j){
		if(!isset($j['p'])) $j['p']='left';
		return $j['p'].' join '.PFX.$j['t'].' on '.$this->___unescape_query($j['on']);
	}
	//------------------------------------------------------------- - -
	function ___unescape_query($arr) 
	{
		if(!is_array($arr)) return $arr;
		if(strpos($arr[0], '?')===false) return $arr[0];
		$sql_stains = explode('?', $arr[0]);
//		echo '$sql_stains are:';dumpVar($sql_stains);
		for($i=1;$i<count($arr);$i++) {				
			$sql_stains[$i-1] .=
				( (is_null($arr[$i]) || $arr[$i]===false) 
				? 'NULL' : '"'. escape_string($arr[$i]).'"');
		}
		$result = implode($sql_stains);
		return $result;		
	}
	//------------------------------------------------------------- - -
	function ___parse_set_data($d){
		$ret = array();
		foreach ($d as $k=>$v){
			$ret[] = $k.' = "'.escape_string($this->enc_var($v)).'"';
		}
		if(!count($ret)) return '';
		return implode(', ', $ret);
	}
	function enc_var($v){
		if(is_bool($v)) $v='xkdb:::'.($v?'true':'false');
		else if(is_null($v))$v = 'xkdb:::null';
		return $v;
	}
	function dec_var($v){
		if($v=='xkdb:::true')$v=true;
		if($v=='xkdb:::false')$v=false;
		if($v=='xkdb:::null')$v=null;
		return $v;
	}
	
}

//////////////////////////////////////////////////////////////////////

?>