<?php
function recursive_remove_directory($directory, $empty=FALSE)
 {
     if(substr($directory,-1) == '/')
     {
         $directory = substr($directory,0,-1);
     }
     if(!file_exists($directory) || !is_dir($directory))
     {
         return FALSE;
     }elseif(is_readable($directory))
     {
         $handle = opendir($directory);
         while (FALSE !== ($item = readdir($handle)))
         {
             if($item != '.' && $item != '..')
             {
                 $path = $directory.'/'.$item;
                 if(is_dir($path)) 
                 {
                    recursive_remove_directory($path);
                 }else{
                     @unlink($path);
                 }
             }
        }
         closedir($handle);
         if($empty == FALSE)
         {
             if(!@rmdir($directory))
             {
                 return FALSE;
             }
         }
     }
    return TRUE;
 }
// ------------------------------------------------------------
$getdirslist_ret_val=array();
function getdirslist($directory, $only='all', $recurs=false, $isfirst=true, $dircapt=false, $force_file_recurs=false){
														//$only: 'dir', 'file', 'all'
		 global $getdirslist_ret_val;												
		 if($dircapt===false)$dircapt=$directory;
		 if($isfirst)													
				 $getdirslist_ret_val = array();
     if(substr($directory,-1) == '/')
         $directory = substr($directory,0,-1);
     if(!file_exists($directory) || !is_dir($directory)){
         return FALSE;
     }else if(is_readable($directory)){
         $handle = @opendir($directory);
		 if($handle){
	          while (FALSE !== ($item = readdir($handle)))
	          {
	             if($item != '.' && $item != '..')
	             {
	             	$y=false;
	             	switch($only){
	             	case 'dir': $y=is_dir($directory.'/'.$item);break;
	             	case 'file': $y=!is_dir($directory.'/'.$item);break;
	             	default: $y=true;break;
	             	}
	             	$iit = (($dircapt==='')?'':($dircapt.'/')).$item;
	             	if($y)
	             		$getdirslist_ret_val[]=$iit;
	             	if(($only!='file' || $force_file_recurs) && $recurs && is_dir($directory.'/'.$item)){
	             		getdirslist($directory.'/'.$item, $only, true, false, 
	             								$dircapt.'/'.$item, $force_file_recurs);
	             	}
	             }
	          }
	          closedir($handle);
		 } 
     }
     
	return $getdirslist_ret_val;
}
function file_is_of_types($fn, $ts){
	$fn = basename($fn);
	if(strpos($fn, '.')===false) return false;
	$f = explode('.', $fn);
	$e = array_pop($f);
	if(!is_array($ts))	return $e == $ts;
	foreach ($ts as $t)
		if($e == $t) return true;
	return false;	
}
function search_files_by_types($path, $types){
//	echo ("Serching in folder $path...\n");
	$r=array();
	$list = getdirslist($path, 'file', true, true, false, true);
	if(array_search($path, $list)===false)
			$list[] = $path;
	foreach ($list as $l){
//		echo "testing \"$l\":";
		if(file_is_of_types(strtolower($l), $types)){
//			echo ".....   matched!";
			$r[] = $l;
		}
//		echo "\n";
	}			
	if(count($r)) return $r;
	return false;
}

function scan_all_paths_for_types($scan_paths, $file_types, $getpaths=false){
	$allm = array();
	foreach ($scan_paths as $k => $v){	
		if(!(file_exists($v) && is_dir($v))) continue;
		$f = search_files_by_types($v, $file_types);
		if($f){
			$allm = array_merge($f, $allm);
		}			
	}
	if(count($allm)){
		if(!$getpaths)	return $allm;
		$bases = array();
		foreach ($allm as $a){
			$bases[dirname($a)] = 1;	
		}
		$r = array();
		foreach ($bases as $k => $v)
			$r[] = $k;
		return $r;	
	}
	return false;		
}
function scan_files_for_sizes($files){
	$r=array();
	if(is_array($files)){
		foreach ($files as $k=>$v){
			$r[$k] = filesize($v);
		}		
	}
	if(count($r)) return $r;
	return false;
}
?>