<?
$xkdb->open_settings('editor');
function apply_all_filters($thim, $filterf){
		global $was_rotated;
		if(ValidVar($filterf, '')=='')return $thim;
		$was_rotated=false;
		$commands = explode('::', $filterf);
		llog('::we have '.count($commands).' commands to do for FLASH.');
		// setting negate and sepia order (negate must be the last)				
		for($i=0;$i<count($commands);++$i){			
			list($f_name, $f_val) = explode(':', $commands[$i]);
			if($f_name=='negate') $neg_i= $i;
		}	
		$com_l = count($commands)-1;
		if(isset($neg_i) && $neg_i!=$com_l){
			llog('negative i is '.$neg_i);
			$temp = $commands[$com_l];
			$commands[$com_l] = $commands[$neg_i];
			$commands[$neg_i] = $temp;
		}
		foreach ($commands as $co){
			list($f_name, $f_val) = explode(':', $co);
			$f_name = str_replace('&', '_', $f_name);
			$funcname = "xk_editor_$f_name";
			llog('       '.$funcname.'("'.$f_val.'")');
			if(function_exists($funcname)){
				$thim = call_user_func($funcname, $thim, $f_val);
			}
			if($f_name=='rotate' && ($f_val==90||$f_val==270))
					$was_rotated=true;
		}			
		return $thim;	
}
function apply_all_filters_server($thim, $filterf){
		if(ValidVar($filterf, '')=='')return $thim;
		$commands = explode('::', $filterf);
		llog('::we have '.count($commands).' commands to do for SERVER.');
		foreach ($commands as $co){
			list($cfitername, $dims) = explode(':', $co);

			$sizesxy = 
				array('width'=>imagesx($thim['im']), 'height'=>imagesy($thim['im']));
			llog("wh: ".print_r($sizesxy, true));
			$dims = explode(';', $dims);
			llog("dims before: ".print_r($dims, true));
			$dims = calc_real_dims($dims, $sizesxy);
			llog("dims after: ".print_r($dims, true));
			
			switch($cfitername){
				case 'redeye': 
					llog("         do_apply_filter_redeye(\$thim, \"".
												print_r($dims, true)."\")");
					$thim = do_apply_filter_redeye($thim, $dims); 
				break;
				case 'crop': 
					llog("         do_apply_filter_crop(\$thim, \"".
												print_r($dims, true)."\")");
					$thim = do_apply_filter_crop($thim, $dims); 
				break;
			}

			
			
		}			
		return $thim;	
}
function xk_editor_negate($img, $prmtr2=false){	
		$rgb = 0;
		$r=0;
		$g=0;
		$b=0;
		$m=0;
		for($y=0;$y<$img['height'];++$y){
			for($x=0;$x<$img['width'];++$x){
					$rgb = ImageColorAt($img['im'], $x, $y);
					$r = 0xFF-(($rgb >> 16) & 0xFF);
					$g = 0xFF-(($rgb >> 8) & 0xFF);
					$b = 0xFF-($rgb & 0xFF);			
					imagesetpixel($img['im'], $x, $y, ($r<<16)|($g<<8)|$b);
			}
		}		
		return $img;
}		
//////////////////////////////////////////////
function xk_editor_redeye($img, $spot=false){	
	if($spot==false){
		$spot['x'] = 40;
		$spot['y'] = 20;
		$spot['diameter'] = 70;
	}
	$spot['diameter'] = abs($spot['diameter']);
	$spot['r'] = $spot['diameter']/2;
	$bl = getSetting('re_c_blur');
	$spot['blur'] = ($bl[0]=='*')
				? $spot['diameter'] * floatval(str_replace('*', '', $bl))
				: floatval($bl);
	return xk_editor_circleImage_redeye($img, 
															$spot['x']+$spot['r'], 
															$spot['y']+$spot['r'], $spot['r'], $spot['blur']); }
//////////////////////////////////////////////
function xk_editor_mixColors($color1, $color2, $q) {
    $r1 = ($color1 >> 16) & 0xFF;
    $g1 = ($color1 >> 8) & 0xFF;
    $b1 = $color1 & 0xFF;
    $r2 = ($color2 >> 16) & 0xFF;
    $g2 = ($color2 >> 8) & 0xFF;
    $b2 = $color2 & 0xFF;
    $r = round($r1*$q + $r2*(1 - $q));
    $g = round($g1*$q + $g2*(1 - $q));
    $b = round($b1*$q + $b2*(1 - $q));
		return ($r << 16) | ($g << 8) | $b;
}
//////////////////////////////////////////////
function xk_editor_circleImage_redeye
									($img, $centerX, $centerY, $radius, $blurBorderWidth = 1) {
		$funcname='xk_editor_circleImage_redeye___'.getSetting('re_c_method');
		return $funcname($img, $centerX, $centerY, $radius, $blurBorderWidth);
}
//////////////////////////////////////////////
function xk_editor_circleImage_redeye___forced_average
									($img, $centerX, $centerY, $radius, $blurBorderWidth = 1) {
    for($x = $centerX - $radius; $x <= $centerX + $radius; $x++)
        for($y = $centerY - $radius; $y <= $centerY + $radius; $y++) {
            $dist = sqrt(pow($x - $centerX, 2) + pow($y - $centerY, 2));
            if($dist > $radius)                            $q = 1;
            elseif($dist < $radius - $blurBorderWidth)    $q = 0;
            else  			$q = 1 - ($radius - $dist)/$blurBorderWidth;
            
						$rgb = @ImageColorAt($img['im'], $x, $y);
						$r = ($rgb >> 16) & 0xFF;
						$g = ($rgb >> 8) & 0xFF;
						$b = $rgb & 0xFF;			
						$m = ((((($g+$b)/2)+$g+$b)/3)<<16)|($g<<8)|$b;
						imagesetpixel($img['im'], $x, $y, xk_editor_mixColors($rgb, $m, $q));
        }
    return $img;
}
//////////////////////////////////////////////
function xk_editor_circleImage_redeye___average
									($img, $centerX, $centerY, $radius, $blurBorderWidth = 1) {
    for($x = $centerX - $radius; $x <= $centerX + $radius; $x++)
        for($y = $centerY - $radius; $y <= $centerY + $radius; $y++) {
            $dist = sqrt(pow($x - $centerX, 2) + pow($y - $centerY, 2));
            if($dist > $radius)                            $q = 1;
            elseif($dist < $radius - $blurBorderWidth)    $q = 0;
            else  			$q = 1 - ($radius - $dist)/$blurBorderWidth;
            
						$rgb = @ImageColorAt($img['im'], $x, $y);
						$r = ($rgb >> 16) & 0xFF;
						$g = ($rgb >> 8) & 0xFF;
						$b = $rgb & 0xFF;			
						$m = ((($g+$b)/2)<<16)|($g<<8)|$b;
						imagesetpixel($img['im'], $x, $y, xk_editor_mixColors($rgb, $m, $q));
        }
    return $img;
}
//////////////////////////////////////////////
function xk_editor_circleImage_redeye___desaturate
									($img, $centerX, $centerY, $radius, $blurBorderWidth = 1) {
    for($x = $centerX - $radius; $x <= $centerX + $radius; $x++)
        for($y = $centerY - $radius; $y <= $centerY + $radius; $y++) {
            $dist = sqrt(pow($x - $centerX, 2) + pow($y - $centerY, 2));
            if($dist > $radius)                            $q = 1;
            elseif($dist < $radius - $blurBorderWidth)    $q = 0;
            else  			$q = 1 - ($radius - $dist)/$blurBorderWidth;
            
						$rgb = @ImageColorAt($img['im'], $x, $y);
						$r = ($rgb >> 16) & 0xFF;
						$g = ($rgb >> 8) & 0xFF;
						$b = $rgb & 0xFF;			
						$m = ($r/2+$g+$b)/3;
						$m = ($m<<16)|($m<<8)|$m;
						imagesetpixel($img['im'], $x, $y, xk_editor_mixColors($rgb, $m, $q));
        }
    return $img;
}
//////////////////////////////////////////////
function xk_editor_circleImage_redeye___dark_desaturate
									($img, $centerX, $centerY, $radius, $blurBorderWidth = 1) {
    for($x = $centerX - $radius; $x <= $centerX + $radius; $x++)
        for($y = $centerY - $radius; $y <= $centerY + $radius; $y++) {
            $dist = sqrt(pow($x - $centerX, 2) + pow($y - $centerY, 2));
            if($dist > $radius)                            $q = 1;
            elseif($dist < $radius - $blurBorderWidth)    $q = 0;
            else  			$q = 1 - ($radius - $dist)/$blurBorderWidth;
            
						$rgb = @ImageColorAt($img['im'], $x, $y);
						$r = ($rgb >> 16) & 0xFF;
						$g = ($rgb >> 8) & 0xFF;
						$b = $rgb & 0xFF;			
						$m = ($g+$b)/2;
						$m = ($m<<16)|($m<<8)|$m;
						imagesetpixel($img['im'], $x, $y, xk_editor_mixColors($rgb, $m, $q));
        }
    return $img;
}
//////////////////////////////////////////////
function xk_editor_circleImage_redeye___treshold
									($img, $centerX, $centerY, $radius, $blurBorderWidth = 1) {
			if(ValidReqVar('xkdtreshold'))
				$th = explode('-', ValidReqVar('xkdtreshold'));
			else	
				$th = explode('-', getSetting('treshold_val'));
							
			$tr = floatval($th[0]);			
			$tg = floatval($th[1]);			
			$tb = floatval($th[2]);
			llog(">>>>>>>>>>>>>>>>treshold_val: $tr, $tg, $tb.");
			
			$tmax = max($tr, max($tg, $tb));
			llog(">>>>>>>>>>>>>>>>max: $tmax.");
			if($tmax!=0){
				$tr /= $tmax;			
				$tg /= $tmax;			
				$tb /= $tmax;
			}			
	    for($x = $centerX - $radius; $x <= $centerX + $radius; $x++)
        for($y = $centerY - $radius; $y <= $centerY + $radius; $y++) {
            $dist = sqrt(pow($x - $centerX, 2) + pow($y - $centerY, 2));
            if($dist > $radius)                            $q = 1;
            elseif($dist < $radius - $blurBorderWidth)    $q = 0;
            else  			$q = 1 - ($radius - $dist)/$blurBorderWidth;
            
						$rgb = @ImageColorAt($img['im'], $x, $y);
						$r = ($rgb >> 16) & 0xFF;
						$g = ($rgb >> 8) & 0xFF;
						$b = $rgb & 0xFF;			
						$zmax = max($r, max($g, $b));
						if($zmax!=0){
							$zr = $r/$zmax;
							$zg = $g/$zmax;
							$zb = $b/$zmax;
						}
						if($zr>=$tr&&$zg<=$tg&&$zb<=$tb){
//							$m = ((((($g+$b)/2)+$g+$b)/3)<<16)|($g<<8)|$b;
							$m = ($r+$g+$b)/4;	
							$m = ($m<<16)|($m<<8)|$m;
						}else 
							$m = $rgb;
						imagesetpixel($img['im'], $x, $y, xk_editor_mixColors($rgb, $m, $q));
        }
    return $img;
}
//////////////////////////////////////////////
function xk_editor_full_redeye_test($img, $tresh){	
		$th = explode('-', $tresh);
		$tr = floatval($th[0]);			
		$tg = floatval($th[1]);			
		$tb = floatval($th[2]);
		llog("$tr-$tg-$tb");
			$tmax = max($tr, max($tg, $tb));
			llog(">>>>>>>>>>>>>>>>max: $tmax.");
			if($tmax!=0){
				$tr /= $tmax;			
				$tg /= $tmax;			
				$tb /= $tmax;
			}			
		$rgb = 0;
		$r=0;
		$g=0;
		$b=0;
		$m=0;
		for($y=0;$y<$img['height'];++$y){
			for($x=0;$x<$img['width'];++$x){
						$rgb = @ImageColorAt($img['im'], $x, $y);
						$r = ($rgb >> 16) & 0xFF;
						$g = ($rgb >> 8) & 0xFF;
						$b = $rgb & 0xFF;			
						$zmax = max($r, max($g, $b));
						if($zmax!=0){
							$zr = $r/$zmax;
							$zg = $g/$zmax;
							$zb = $b/$zmax;
						}
						if($zr>=$tr&&$zg<=$tg&&$zb<=$tb){
							$m = ($r+$g+$b)/4;	
							$m = ($m<<16)|($m<<8)|$m;
						}else 
							$m = $rgb;
					imagesetpixel($img['im'], $x, $y, $m);
			}
		}		
		llog_flush('xk_editor_full_redeye_test');
		return $img;
}		
//////////////////////////////////////////////
function xk_editor_desaturate($img, $prmtr2=false){	
		$rgb = 0;
		$r=0;
		$g=0;
		$b=0;
		$m=0;
		for($y=0;$y<$img['height'];++$y){
			for($x=0;$x<$img['width'];++$x){
					$rgb = ImageColorAt($img['im'], $x, $y);
					$r = ($rgb >> 16) & 0xFF;
					$g = ($rgb >> 8) & 0xFF;
					$b = $rgb & 0xFF;			
					$m = ($r+$g+$b)/3;
					$m = ($m<<16)|($m<<8)|$m;
	//				$res = ($r<<16)|($g<<8)|$b;
					imagesetpixel($img['im'], $x, $y, $m);
			}
		}		
		return $img;
}		
//////////////////////////////////////////////
function xk_editor_flip($img, $prmtr2=false){return xk_editor_flipflop($img, true);}	
function xk_editor_flop($img, $prmtr2=false){return xk_editor_flipflop($img, false);}	
//////////////////////////////////////////////
function xk_editor_flipflop($img, $f=true){	
		$rgb = 0;
		$w = $img['width'];
		$h = $img['height'];
		$ret = imagecreatetruecolor($w, $h);
		for($y=0;$y<$h;++$y){
			for($x=0;$x<$w;++$x){
					$rgb = ImageColorAt($img['im'], $x, $y);
					imagesetpixel($ret, $f?($w-$x):$x, $f?$y:($h-$y), $rgb);
			}
		}		
		$img['im'] = $ret;
		return $img;
}		
//////////////////////////////////////////////
function xk_editor_rotate($img, $d){
	return call_user_func("xk_editor_rotate$d", $img);
}
//////////////////////////////////////////////
function xk_editor_rotate90($img, $p=false){	
		$rgb = 0;
		$w = $img['width'];
		$h = $img['height'];
		$ret = imagecreatetruecolor($h, $w);
		for($y=0;$y<$h;++$y){
			for($x=0;$x<$w;++$x){
					$rgb = ImageColorAt($img['im'], $x, $y);
					imagesetpixel($ret, $h-$y, $x, $rgb);
			}
		}		
		$img['im'] = $ret;
		return $img;
}		
//////////////////////////////////////////////
function xk_editor_rotate270($img, $p=false){	
		$rgb = 0;
		$w = $img['width'];
		$h = $img['height'];
		$ret = imagecreatetruecolor($h, $w);
		for($y=0;$y<$h;++$y){
			for($x=0;$x<$w;++$x){
					$rgb = ImageColorAt($img['im'], $x, $y);
					imagesetpixel($ret, $y, $w-$x, $rgb);
			}
		}		
		$img['im'] = $ret;
		return $img;
}		
//////////////////////////////////////////////
function xk_editor_rotate180($img, $p=false){	
		$rgb = 0;
		$w = $img['width'];
		$h = $img['height'];
		$ret = imagecreatetruecolor($w, $h);
		for($y=0;$y<$h;++$y){
			for($x=0;$x<$w;++$x){
					$rgb = ImageColorAt($img['im'], $x, $y);
					imagesetpixel($ret, $w-$x, $h-$y, $rgb);
			}
		}		
		$img['im'] = $ret;
		return $img;
}		
//////////////////////////////////////////////
// if ffffff - only desaturate.
function xk_editor_b_w($img, $clr=0xffffff){	
		if($clr=='-') $clr=0xffffff;
		if($clr==0xffffff) return  xk_editor_desaturate($img);
		if(is_string($clr) && strpos($clr, '-')!==false){
			$clrt = explode('-', $clr);
			$clr = (intval($clrt[0])<<16)|(intval($clrt[1])<<8)|intval($clrt[2]);
		}
		$cr = 0xFF - (($clr >> 16) & 0xFF);
		$cg = 0xFF - (($clr >> 8) & 0xFF);
		$cb = 0xFF - ($clr & 0xFF);			
//		echo "$cr-$cg-$cb<br>";
		$rgb = 0;
		$r=0;
		$g=0;
		$b=0;
		$m=0;
		for($y=0;$y<$img['height'];++$y){
			for($x=0;$x<$img['width'];++$x){
					$rgb = ImageColorAt($img['im'], $x, $y);
					$r = ($rgb >> 16) & 0xFF;
					$g = ($rgb >> 8) & 0xFF;
					$b = $rgb & 0xFF;			
					$m = ($r+$g+$b)/3;					
	//				$res = ($r<<16)|($g<<8)|$b;
					imagesetpixel($img['im'], $x, $y, 
							(max(0, $m-$cr)<<16)|(max(0, $m-$cg)<<8)|max(0, $m-$cb));
			}
		}		
		return $img;
}		
//////////////////////////////////////////////
function xk_editor_auto($img, $prmtr2=false){	
	// calculating the current page:
	$rgb = 0;
	$r=0;
	$g=0;
	$b=0;
	$r_mi=255;
	$g_mi=255;
	$b_mi=255;
	$r_ma=0;
	$g_ma=0;
	$b_ma=0;
	$space=8;
	$fin=100;
		for($y=0;$y<$img['height']-$space+1;$y+=$space){
			for($x=0;$x<$img['width']-$space+1;$x+=$space){
					$rgb = ImageColorAt($img['im'], $x, $y);
					$r = ($rgb >> 16) & 0xFF;
					$g = ($rgb >> 8) & 0xFF;
					$b = $rgb & 0xFF;			
					$r_mi = min($r_mi, $r);
					$g_mi = min($g_mi, $g);
					$b_mi = min($b_mi, $b);
					$r_ma = max($r_ma, $r);
					$g_ma = max($g_ma, $g);
					$b_ma = max($b_ma, $b);
//					if($fin-- >=0)echo "$r-$g-$b<br>\n";
			}
		}		
		// calculated. Now ppling using this sheme:
		//    (color - min) * 255/(max-min)
//		echo "r min: $r_mi<br>";
//		echo "g min: $g_mi<br>";
//		echo "b min: $b_mi<br>";
//		echo "r max: $r_ma<br>";
//		echo "g max: $g_ma<br>";
//		echo "b max: $b_ma<br>";
		$r_ma=255/($r_ma-$r_mi);
		$g_ma=255/($g_ma-$g_mi);
		$b_ma=255/($b_ma-$b_mi);
		
		for($y=0;$y<$img['height'];++$y){
			for($x=0;$x<$img['width'];++$x){
					$rgb = ImageColorAt($img['im'], $x, $y);
					$r = intval(((($rgb >> 16) & 0xFF)-$r_mi)*$r_ma);
					$g = intval(((($rgb >> 8) & 0xFF)-$g_mi)*$g_ma);
					$b = intval(((($rgb ) & 0xFF)-$b_mi)*$b_ma);
					imagesetpixel($img['im'], $x, $y, 
								(min($r, 0xff)<<16)|(min($g, 0xff)<<8)|min($b, 0xff));
			}
		}		
		return $img;
		
}	
//////////////////////////////////////////////
function xk_editor_open_file($filename, $type='jpeg'){ 
	$ret['im']=call_user_func("imageCreateFrom$type", $filename);
	$ret['width'] = imagesx($ret['im']);
	$ret['height'] = imagesy($ret['im']);
	return $ret; 
}	
//////////////////////////////////////////////
function xk_editor_save_file($img, $filename, $quality=80){ 
	xkimagejpeg($img['im'], $filename, $quality);
	$oldmask = @umask(0); 
    chmod($filename, 0777);
	@umask($oldmask);	
}	
//--------------------------------------------
//--------------------------------------------
//--------------------------------------------
//////////////////////////////////////////////
//////////////////////////////////////////////
//////////////////////////////////////////////

?>