<?

require_once($SYSPATH.'funcs/xml/domit/xml_domit_include.php');

//=============================================================================
class spoxml{
	var $___photos;
	var $___customer_info;
	var $id;
	var $datetime;
	var $generator;
	var $ip;
//=============================================================================
	function spoxml($fname=false){
		$this->___photos = array();
		$this->___customer_info = array();
		if($fname!==false)
			$this->openFile($fname);
	}
//=============================================================================
	function set_order_properties($id, $datetime, $generator, $ip=''){
		$this->id = $id;
		$this->datetime = $datetime;
		$this->generator = $generator;
		$this->ip = $ip;
	}
//=============================================================================
	function get_order_properties(){
		return array(
					'id'=>$this->id,
					'datetime'=>$this->datetime,
					'generator'=>$this->generator,
					'ip'=>$this->ip,
					);		
	}
//=============================================================================
	function add_photo($filename, $size, $surface, $border_color, $amount,
						$ff='', $fc=''){
				$ci = count($this->___photos);
				$this->___photos[$ci]['name'] = $filename;
				$this->___photos[$ci]['size'] = $size;
				$this->___photos[$ci]['surface'] = $surface;
				$this->___photos[$ci]['border'] = $border_color;
				$this->___photos[$ci]['amount'] = $amount;
				$this->___photos[$ci]['ff'] = $ff;
				$this->___photos[$ci]['fc'] = $fc;
	}
//=============================================================================
	function get_photo_total(){  return count($this->___photos); }
//=============================================================================
	function get_photo($i){
		if(count($this->___photos)>$i) return $this->___photos[$i];
		return false;
	}
//=============================================================================
	function add_user_info($props){
		foreach ($props as $i => $v){
			if($i=='Password' ||$i=='Repeat password') continue;
			$this->___customer_info[$i] = $v;
		}
	}
//=============================================================================
	function get_user_info($key=null){
		if(isset($this->___customer_info[$key])) return $this->___customer_info[$key];
		return false;
	}
//=============================================================================
	function hs($a){ return htmlspecialchars($a); }
//=============================================================================
	function generate(){
		$out = '<?xml version="1.0"?>'."\n".'<spoxml type="order" generator="'
									.$this->hs($this->generator)
									.'" ip="'.$this->hs($this->ip).'">'."\n";
		$out .= '<order id="'. $this->hs($this->id)
										.'" datetime="'.$this->hs($this->datetime).'">'."\n";
		foreach ($this->___customer_info as $a=>$b){
			$out .= "\t".'<prop name="'.$a.'" value="'.$b.'" />'."\n";
		}
		$out .= '</order>'."\n";
		$out .= "<cds type=\"".$this->hs($this->cds)."\" num=\"".$this->cdsnum."\" />\n";
		$out .= '<photos>'."\n";
		foreach ($this->___photos as $a=>$b){
			$out .= "\t".'<photo '."\n\t\t".'name="'.$b['name'].'" '."\n\t\t".'size="'.$b['size']
										.'" '."\n\t\t".'ff="'.$b['ff']
										.'" '."\n\t\t".'fc="'.$b['fc']
										.'" '."\n\t\t".'surface="'.$b['surface']
										.'" '."\n\t\t".'border="'.$b['border']
										.'" '."\n\t\t".'amount="'.$b['amount'].'" />'."\n";
		}
		$out .= '</photos>'."\n";
		$out .= '</spoxml>';
		return $out;
	}
//=============================================================================
	function generateHTML($photosPath=''){
		if($photosPath!='')$photosPath.='/';
		$out = '';
		$outtitle = 'Order #'.$this->id.'';
		$out .= "
<html>
<!-- based on the following SPO XML:
============================================================
".$this->generate()."
============================================================
-->
<style>
body, td{
	font-family:Verdana,Tahoma,Arial; 
	font-size:11px; 
	color:#111; 
	background-color:#C4C4FF;
}
table { border: 1px solid #99c; }
td { border: 1px solid #bbe; }
h1 { font-size:20pt; }
h2 { font-size:15pt; }
.sm { font-size:8pt;color:#444; }
</style>
<title>$outtitle</title>
<body>
<h1>$outtitle</h1>
<span class=sm>$this->datetime, client ip address: $this->ip</span>
<br>
<h2>Order info:</h2>
<table cellspacing=0 cellpadding=4>
		";
		foreach ($this->___customer_info as $a=>$b){
			$out .= "<tr><td align=right>&nbsp;<b>$a</b></td><td nowrap align=left>$b&nbsp;</td></tr>";
		}
		
		$out .= "</table>";
	$cds = $this->hs($this->cds);	
	if($cds=='only'){
		$out .= "<b>CDs: only burn CDs, don't print photos, amount: $this->cdsnum;</b><br>";
	}
	else if($cds!='none'){
		$out .= "<b>CDs: from ".$cds." photos, amount: $this->cdsnum;</b><br>";
	}
$out .= "		
<h2>Photos:</h2>
<table border=0 cellpadding=4 width=\"100%\" align=right>
<tbody valign=top align=left>
		";
		foreach ($this->___photos as $a=>$b){
			$out .="
			<tr>".
				(($cds=='only')?'':(
					"<td align=right nowrap width=\"50%\">
						<img src=\"".replace_divider($photosPath.$b['name'])."\" width=\"50%\"></td>"))
				."
				<td width=\"50%\">
					<b>size:</b> ".$b['size']."<br>
					<b>surface:</b> ".$b['surface']."<br>
					<b>border:</b> ".get_setting_n($b['border']).
					($b['border']!='-'?
					"&nbsp;<span style=\"background-color:#".$b['border']."\">&nbsp;&nbsp;&nbsp;</span>":'').
					"<br>
					<b>amount:</b>".$b['amount']."<br>
					-------------------<br>
					".(($cds=='only')?'':(
						"<a href=\"".replace_divider($photosPath.$b['name'])."\" class=sm>[Show full size]</a>"))."
				</td>
			</tr>				
		";
		}
		$out .= "
</table>		
<br><br>
<div align=right class=sm>generated by $this->generator</div>
</body>
</html>
		";
		return $out;		
	}
//=============================================================================
	function generateXkReport(){
		$nln="\r\n";
		$cui = $this->___customer_info;
		$uname=
			isset($cui['Last name'])
			?((
				isset($cui['First name'])
				?
					($cui['First name'].' '.$cui['Last name'])
				:
					($cui['Last name'])
				).  ' ('.$cui['Login'].')')
			:$cui['Login'];
		$uphone=ValidVar($cui['Phone'], '-');
		$uaddress=
			ValidVar($cui[urldecode('P.O+Box+or+Street+Address')], 
				ValidVar($cui['Address'], '-'));
		$ucds = $this->hs($this->cds)!='none'?$this->cdsnum:0;
		
		$out="";
		$out.=$this->id.$nln;
		$out.=$uname.$nln;
		$out.=$uphone.$nln;
		$out.=$uaddress.$nln;
		$out.=$ucds.$nln;
		$out.=unify_price($cui['price']).$nln;
		$ph_summ=array();
		foreach ($this->___photos as $a=>$b){
			if(!isset($ph_summ[$b['size']]))$ph_summ[$b['size']]=0;
			$ph_summ[$b['size']]++;
		}
		$ph_summary=array();
		foreach ($ph_summ as $k=>$v) $ph_summary[] = "$k=$v";			
		$out.=implode('&', $ph_summary).$nln;

		$ph_summary=array();
		foreach ($this->___photos as $a=>$b){
				$ph_summary[]=
					basename($b['name'])
					.'?'.$b['size']
					.':'.$b['amount'];
		}
		$out.=implode('*', $ph_summary);
		llog_add(__FILE__, __LINE__, "\n=======================\n$out\n\n\n\n");
		return $out;
	}
//=============================================================================
	function generateTXT($photosPath='', $fu=''){
		$for_user = ($fu=='for user');
		if($photosPath!='')$photosPath.='/';
		$out = '';
		$outtitle = 'Order #'.$this->id.'';
		$spl = '=====================================================================';
		$spp = '---------------------------------------------------------------------';
		$orddt = $this->datetime.($for_user?'':", IP: $this->ip");
		$gen = ($for_user?'':"\n\ngenerated by $this->generator");
		$out .= "$outtitle
$spl		
    			$orddt       
$spl
		
ORDER INFO:
$spp
";
		foreach ($this->___customer_info as $a=>$b){
			$out .= str_repeat(' ', max(0, 30-strlen($a)))."$a: $b\n";
		}
		if($this->hs($this->cds)=='only'){
			$out .= "$spl		
CDs: only burn CDs, don't print photos, amount: $this->cdsnum;
";
		}else if($this->hs($this->cds)!='none'){
			$out .= "$spl		
CDs: from ".$this->hs($this->cds)." photos, amount: $this->cdsnum;
";
		}
		$out .= "$spl
		
PHOTOS:
$spp
";
		foreach ($this->___photos as $a=>$b){
			$out .=
"".basename($b['name']).($for_user?'':"
    ".replace_divider($photosPath.$b['name']))."
    size: ".$b['size']."
		surface: ".$b['surface']."
		border: ".get_setting_n($b['border'])." (".$b['border'].")
		amount: ".$b['amount']."
		
";
		}
		$out .= 
"
$spl$gen
";
		return $out;		
	}
//=============================================================================
	function generateShortDesc($photosPath='', $fu=''){
		$for_user = ($fu=='for user');
		if($photosPath!='')$photosPath.='/';
		$nm = '';
		if($this->get_user_info('Name'))$nm.=$this->get_user_info('Name');
		else if($this->get_user_info('First name'))
				$nm.=$this->get_user_info('First name');
		$nm .= 		$this->get_user_info('Last name');
		$out = 'Order by &lt;b&gt;'.
							$nm.
							' ('.$this->get_user_info('Login').')'.
							'&lt;/b&gt; at &lt;b&gt;'.$this->datetime.'&lt;/b&gt;.&lt;br /&gt;';
		if($this->get_user_info('price')){
			$out .= 'Price &lt;b&gt;'.trim($this->get_user_info('price')).'&lt;/b&gt;.&lt;br /&gt;';
		}				
		$out .= 'Photos: &lt;b&gt;'.count($this->___photos).'&lt;/b&gt;.&lt;br /&gt;';					
		if($this->hs($this->cds)=='only'){
			$out .= "
			&lt;b&gt;$this->cdsnum&lt;/b&gt; CDs, only burn CDs, don't print photos.";
		}
		else if($this->hs($this->cds)!='none'){
			$out .= "&lt;b&gt;$this->cdsnum&lt;/b&gt; CDs from ".$this->hs($this->cds).' photos.';
		}
		return $out;		
	}
//=============================================================================
	function generateDPOF($head_tpl, $job_tpl){
		$out='';
		$out.=
		mass_str_replace(
					array(
						'<[_GEN_CRT_]>' => "\"XKIOSK/300/$this->generator\"",
						'<[_GEN_DATETIME_]>' => date("Y:m:d:H:i:s"),
						'' => '',
					), 
					$head_tpl)."\n\n";
		foreach ($this->___photos as $a=>$b){
			if($b['amount']<=0) continue;
			$aa = str_pad(strval(intval($a+1)), 3, "0", STR_PAD_LEFT);  	
			$am = str_pad(strval($b['amount']), 3, "0", STR_PAD_LEFT);  	
			$out.=
			mass_str_replace(
						array(
							'<[_PID_]>' => $aa,
							'<[_TYPE_]>' => 'STD',
							'<[_QUANTITY_]>' => $am,
							'<[_SIZE_]>' => $b['size'],
							'<[_SURFACE_]>' => $b['surface'],
							'<[_BORDER_COLOR_]>' => $b['border'],
							'<[_BORDER_COLOR_NAME_]>' => get_setting_n($b['border']),
							'<[_IMAGE_FORMAT_]>' => 'JFIF',
							'<[_IMAGE_PATH_]>' => "../DCIM/101_XKIO/DSCF0$aa.JPG",
						), 
						$job_tpl)."\n\n";
			
		}
		return $out;
	}
//=============================================================================
	function openFile($fname){
		if(!file_exists($fname)) return false;
		return $this->parseText(file_get_contents($fname));
	}
//=============================================================================
	function parseText($txt){
		$this->___photos = array();
		$this->___customer_info = array();
		$domit =& new DOMIT_Document();
		//use parseXML method to populate document
		if($domit->parseXML($txt, true)!=true){
			return 'Error: cannot parse the SPOML text';
		}
//		echo htmlspecialchars($txt)."<br>";
		$el_spoxml =& $domit->documentElement;
		$this->generator = $el_spoxml->getAttribute('generator');
		$this->ip = $el_spoxml->getAttribute('ip');
		if($el_spoxml->nodeName!='spoxml')
				return 'Error: this is not a SPOXML file.';
		if($el_spoxml->getAttribute('type')!='order')
				return 'Error: this SPOXML file is not an order, this is "'.
																						$el_spoxml->getAttribute('type').'".';
		if(!$el_spoxml->hasChildNodes()) return false;
		$nodes_l1 = $el_spoxml->childNodes;
		for($i=0;$i < $el_spoxml->childCount;++$i){
			$node_l1 =& $nodes_l1[$i];
			switch ($node_l1->nodeName){
				case 'photos':
					$nodes_l2 = $node_l1->childNodes;
					for($j=0;$j<$node_l1->childCount;++$j){
						$node_l2 =& $nodes_l2[$j];
						$this->add_photo($node_l2->getAttribute('name'), 
									 $node_l2->getAttribute('size'), 
									 $node_l2->getAttribute('surface'),
									 $node_l2->getAttribute('border'),
									 $node_l2->getAttribute('amount'),
									 $node_l2->getAttribute('ff'),
									 $node_l2->getAttribute('fc')
										);
					}
				break;
				case 'cds':
						$this->cds = $node_l1->getAttribute('type');
						$this->cdsnum = $node_l1->getAttribute('num');
				break;
				case 'order':
					$this->id = $node_l1->getAttribute('id');
					$this->datetime = $node_l1->getAttribute('datetime');
					$nodes_l2 = $node_l1->childNodes;
					for($j=0;$j<$node_l1->childCount;++$j){
						$node_l2 =& $nodes_l2[$j];
						$this->___customer_info[$node_l2->getAttribute('name')] = 
															$node_l2->getAttribute('value');
					}					
				break;
			}
		}
		return true;
	}
//=============================================================================
	function setCds($t, $n){ $this->cds=$t;  $this->cdsnum=$n; }
//=============================================================================
	function getCds(){ return $this->cds; }
//=============================================================================
	function getCdsNum(){ return $this->cdsnum; }
//=============================================================================
	function toString(){
		$out = '';
		$out .= 'generator: '. $this->generator."\n";
		$out .= 'ip: '. $this->ip."\n";
		$out .= 'order id: '. $this->id."\n";
		$out .= 'date: '. $this->datetime."\n";
		$out .= "\n";
		$out .= "cds: ".$this->cds.", num: ".$this->cdsnum."\n";
		$out .= "\n";
		$out .= 'Info: '."\n";
		foreach ($this->___customer_info as $a=>$b){
			$out .= '    '.$a.': '.$b."\n";
		}
		$out .= "\n";
		$out .= 'Photos: '."\n";
		foreach ($this->___photos as $a=>$b){
			$out .= '    '.$a.': '.$b['name'].', '.$b['size'].', '.
										$b['surface'].', '.$b['border'].', '.$b['amount'].';'."\n";
		}
		return $out;
	}
};








?>